'
' User: Kristian
' Date: 07.08.2005
' Time: 03:25
' 
Imports System
Imports Microsoft.VisualBasic

Module GuessGame

    ' The range the calculated numbers are within
    Public MinNumber As Double
    Public MaxNumber As Double

    Public Sub Main()

        ' Write the intro
        Console.WriteLine("### Welcome to GuessGame             ###")
        Console.WriteLine("### Made by Kristian S. Stangeland   ###")
        Console.WriteLine("### Type 4 to configure number range ###")
        Console.WriteLine()

        ' Set default values
        MinNumber = 1
        MaxNumber = 50

        ' Make a loop
        Do

            ' Invoke the game
            StartGame()

            ' Now, ask if we should play again
            If RetrieveAnswer("Do you want to play again (Y/N)").ToUpper = "N" Then
                Exit Do
            End If

        Loop

    End Sub

    ' Sets the minimum and maximum numbers
    Public Sub ConfigureRange()

        Try

            ' Set the variables
            MinNumber = Double.Parse(RetrieveAnswer("Set the minimum number"))
            MaxNumber = Double.Parse(RetrieveAnswer("Set the maximum number"))

        Catch ex As Exception

            ' Inform about the error
            Console.WriteLine("Syntax error.")

        End Try

    End Sub

    Public Sub StartGame()

        Dim iLevel As Integer, iNumber As Integer, iTries As Integer, iGuess As Integer
        Dim Random As New Random(DateTime.Now.Millisecond), iMax As Integer

        Do

            ' Firstly, get the level to play
            iLevel = Val(RetrieveAnswer("Which level do you want to play (1-3)"))

            ' Only continue if the answer is valid
            If iLevel >= 1 And iLevel <= 3 Then
                Exit Do
            ElseIf iLevel = 4 Then
                ' Upon writing 4, allow configuring the range.
                ConfigureRange()
            End If

        Loop

        ' Calulate the random number
        iNumber = (Random.NextDouble * (MaxNumber - MinNumber)) + MinNumber

        ' Now, calculate the maximum of tries
        iMax = (4 - iLevel) * 3

        ' Then set the amount of tries
        iTries = iMax

        ' Continue guessing until all tries are used
        Do

            ' Ask the user
            iGuess = Val(RetrieveAnswer("Guess a number between " & MinNumber & _
                      " and " & MaxNumber & " (" & iTries & " tries left)"))

            ' Firstly, we must see if the number actually is in the right range
            If iGuess >= MinNumber And iGuess <= MaxNumber Then

                ' Check and see if the number correspond, or give an appropriate answer
                Select Case iGuess

                    ' If the user has guessed the number, ...
                    Case iNumber

                        ' ... he/she has won the game
                        Console.WriteLine("Congratulations! You guessed the number in " & iMax - iTries + 1 & " tries/try!")
                        Exit Sub

                    Case Is < iNumber

                        ' Tell the user that the number guessed is smaller 
                        Console.WriteLine("The number " & iGuess & " is smaller than X.")

                    Case Else

                        ' Tell the user that the number guessed is larger
                        Console.WriteLine("The number " & iGuess & " is larger than X.")

                End Select

                ' Decrease the try-count
                iTries = iTries - 1

            End If

        Loop While iTries > 0

        ' Tell the user that he/she have lost
        Console.WriteLine("I'm sorry, you've lost. The number was " & iNumber & ".")

    End Sub

    Public Function RetrieveAnswer(ByVal sQuestion As String) As String

        ' Now, write the question
        Console.Write(sQuestion & ": ")

        ' Then, wait until the user has pressed enter and return the input
        RetrieveAnswer = Console.ReadLine()

    End Function

End Module
